// -*- java -*-

namespace ICSTARS {

using System;

public class Debug
{
    public static void printMessage(object msg)
    {
	Console.WriteLine("DEBUG: {0}", msg);
    }
    public static void printMessage(object msg1, object msg2)
    {
	Console.WriteLine("DEBUG: {0} {1}", msg1, msg2);
    }


    // Instrumentation for beginning of methods.
    public static bool methodPrintOn = false;
    public static void methodBegin(object receiver, string methodName)
    {
	if ( methodPrintOn ) {
	    Console.WriteLine("DEBUG: METHOD: {{ {0}.{1}() ", receiver, methodName);
	}
    }

    public static void methodBegin(object receiver, string methodName, object arg1)
    {
	if ( methodPrintOn ) {
	    Console.WriteLine("DEBUG: METHOD: {{ {0}.{1}({2})", receiver, methodName, arg1);
	}
    }

    // Instrumentation for end of methods.
    public static void methodEnd(object receiver, string methodName)
    {
	if ( methodPrintOn ) {

	    Console.WriteLine("DEBUG: METHOD: }} {0}.{1}(...)", receiver, methodName);
	}
    }

    public static object methodEnd(object receiver, string methodName, object result)
    {
	if ( methodPrintOn ) {
	    Console.WriteLine("DEBUG: METHOD: }} {0}.{1}(...) => {2}", receiver, methodName, result);
	}
	return result;
    }


    // Assertion check.
    public static void assert(string expression, bool okay)
    {
	if ( ! okay ) {
	    printMessage("ASSERTION FAILED:", expression);
	    throw (new Exception());
	}
    }

}


/*

public class App
{

    public App()
    {
    }

    public void aMethod(int x)
    {
	Debug.methodBegin(this, "aMethod");
	Debug.assert("x > 0", x > 0);
	Debug.methodEnd  (this, "aMethod");	
    }


    public static void Main(string[] args)
    {
	Debug.methodBegin(null, "Main");
	App a = new App();
	a.aMethod(0);
	Debug.methodEnd  (null, "Main");
    }
}

*/

}

